OUTPUT_FORMAT("binary")
ENTRY(_start)

SECTIONS
{
    .header : AT(0) {
        LONG(
              (0x8a97 & 0x000000ff) << 24
            | (0x8a97 & 0x0000ff00) << 8
            | (0x8a97 & 0x00ff0000) >> 8
            | (0x8a97 & 0xff000000) >> 24
        ) /* Magic number (amd64) */
        LONG(
              (SIZEOF(.text) & 0x000000ff) << 24
            | (SIZEOF(.text) & 0x0000ff00) << 8
            | (SIZEOF(.text) & 0x00ff0000) >> 8
            | (SIZEOF(.text) & 0xff000000) >> 24
        )
        LONG(
              (SIZEOF(.data) & 0x000000ff) << 24
            | (SIZEOF(.data) & 0x0000ff00) << 8
            | (SIZEOF(.data) & 0x00ff0000) >> 8
            | (SIZEOF(.data) & 0xff000000) >> 24
        )
        LONG(
              (SIZEOF(.bss) & 0x000000ff) << 24
            | (SIZEOF(.bss) & 0x0000ff00) << 8
            | (SIZEOF(.bss) & 0x00ff0000) >> 8
            | (SIZEOF(.bss) & 0xff000000) >> 24
        )
        LONG(0) /* Symbol table */

        LONG(0) /* Kernel Entry */
        LONG(0) /* spsz */
        LONG(0) /* pcsz */

        LONG(0)
        LONG(
              (_start & 0x000000ff) << 24
            | (_start & 0x0000ff00) << 8
            | (_start & 0x00ff0000) >> 8
            | (_start & 0xff000000) >> 24
        ) /* Entry point */
    } 

    .text 0x200028 : AT(SIZEOF(.header)) {
        *(.init)
        *(.text .text.* .stub)
        *(.fini)

        __ehdr_start = .;
        *(.eh_frame_hdr)
        *(.eh_frame)  
        *(.ctors)
        *(.dtors)

        *(.got)
        *(.got.*)
        *(.plt)
        *(.plt.*)
        *(.iplt)
        *(.iplt.*)

        PROVIDE_HIDDEN(__preinit_array_start = .);
        KEEP(*(.preinit_array))
        PROVIDE_HIDDEN(__preinit_array_end = .);

        PROVIDE_HIDDEN(__init_array_start = .);
        KEEP(*(.init_array))
        PROVIDE_HIDDEN(__init_array_end = .);

        KEEP(*(.fini_array))
        *(.gcc_except_table)

        *(.rodata .rodata.*)
    }

    .data ALIGN(0x200000) : AT(SIZEOF(.header) + SIZEOF(.text)) {
        *(.data .data.* .ldata .ldata.*)

        _tls_start = .;
        _tdata_start = .;
        *(.tdata .tdata.*)
        _tdata_end = .;
        _tbss_start = .;
        *(.tbss .tbss.*)
        _tbss_end = .;
        _tls_end = .;
    }

    .bss : {
        *(.bss .bss.*)
        *(.lbss .lbss.*)
    }
    _file_end = SIZEOF(.header) + SIZEOF(.text) + SIZEOF(.data) + SIZEOF(.bss);
    _mem_end = .;

    /DISCARD/ : {
        *(*)
    }
}
