#include <stdint.h>
#include <_9syscall.h>
#include <time.h>
#include <errno.h>
#include <_9.h>
#include "util.h"

static int nsec_fd;

uint64_t __nsec(void)
{
	int8_t b[8];
	if (!nsec_fd)
		nsec_fd = _9syscall_2(SYS_OPEN, (uvlong) "/dev/bintime", OREAD);
	if (_9syscall_4(SYS_PREAD, nsec_fd, (uvlong) b, 8, 0) != 8)
	{
		_9syscall_1(SYS_CLOSE, nsec_fd);
		nsec_fd = 0;
		return 0;
	}
	return be2uint64(b);
}

int _9clock_gettime(clockid_t clk_id, struct timespec *tp)
{
	switch (clk_id)
	{
	case CLOCK_REALTIME:
	case CLOCK_REALTIME_COARSE:
	case CLOCK_MONOTONIC:
	case CLOCK_MONOTONIC_COARSE:
	{
		uint64_t ns = __nsec();
		tp->tv_sec = ns / 1000000000;
		tp->tv_nsec = ns % 1000000000;
		break;
	}
	default: UNIMPLEMENTED;
	}

	return 0;
}
