#ifndef P9_H
#define P9_H

#include <stdint.h>
#include <sys/types.h>
#include <unistd.h>
#include <poll.h>
#include <signal.h>
#include <limits.h>
#include <sys/select.h>

ssize_t _9write(int fd, const void *buf, size_t count);
ssize_t _9read(int fd, void *buf, size_t count);
ssize_t _9pwrite(int fd, const void *buf, size_t count, off_t offset);
ssize_t _9pread(int fd, void *buf, size_t count, off_t offset);
int _9open(const char *file, int flags, int mode);
int _9creat(const char *file, int mode);
int _9close(int fd);
ssize_t _9lseek(int fd, off_t offset, int whence);
ssize_t _9writev(int fd, const struct iovec *iov, int iovcnt);
ssize_t _9readv(int fd, const struct iovec *iov, int iovcnt);
int _9ioctl(int fd, unsigned long request, ...);
int _9poll(struct pollfd *fds, nfds_t nfds, int timeout);
int _9select(
		int nfds,
		fd_set *readfds,
		fd_set *writefds,
		fd_set *exceptfds,
		struct timeval *timeout);
int _9fcntl(int fd, int cmd, long arg);
int _9unlink(const char *pathname);
ssize_t _9readlink(
		const char *restrict pathname,
		char *restrict buf,
		size_t bufsiz);

int _9clock_gettime(clockid_t clk_id, struct timespec *tp);

pid_t _9getpid(void);
pid_t _9getppid(void);
pid_t _9gettid(void);

pid_t _9fork(void);

void *_9mmap(
		void *addr,
		size_t length,
		int prot,
		int flags,
		int fd,
		off_t offset
	);
int _9munmap(void *addr, size_t length);

pid_t _9set_tid_address(int *tidptr);
int _9set_thread_area(struct user_desc *u_info);
int _9arch_prctl(int code, unsigned long *addr);

__attribute__((noreturn)) void _9exit(int n);

void _9siglock(void);
void _9sigunlock(void);
int _9rt_sigaction(
		int signum,
		const struct sigaction *restrict act,
		struct sigaction *restrict oact,
		size_t sigsetsize);
int _9rt_sigprocmask(
		int how,
		const sigset_t *set,
		sigset_t *oldset,
		size_t sigsetsize);


int _9stat(const char *restrict pathname, struct stat *restrict statbuf);
int _9fstat(int fd, struct stat *restrict statbuf);
int _9truncate(const char *pathname, off_t length);
int _9ftruncate(int fd, off_t length);

char *_9getcwd(char *buf, size_t size);

ssize_t _9getrandom(void *buf, size_t buflen, unsigned int flags);

#ifdef _STRACE
extern _Bool _strace_on, _init_done;
#endif

#ifdef _STRACE
#include <stdio.h>
#define _STRACE_PRINT(...) \
    do if (_strace_on && _init_done) \
	{ \
		_strace_on = 0; \
		printf(__VA_ARGS__); \
		fflush(stdout); \
		_strace_on = 1; \
	} while (0)
#else
#define _STRACE_PRINT(...)
#endif

#ifdef _STRACE_FAILS
#include <stdio.h>
#define _FAIL_PRINT(...) do { printf(__VA_ARGS__); fflush(stdout); } while (0)
#else
#define _FAIL_PRINT(...)
#endif


#define UNIMPLEMENTED do {\
        _STRACE_PRINT("cross9: Unimplemented: %s\n", __func__); \
        return -ENOSYS; \
    } while (0)



#endif
