#ifndef SYSCALL9_H
#define SYSCALL9_H
#include <stdio.h>

typedef unsigned long long uvlong;

enum
{
    SYS_ERRSTR     = 0x01,
    SYS_BIND       = 0x02,
    SYS_CHDIR      = 0x03,
    SYS_CLOSE      = 0x04,
    SYS_DUP        = 0x05,
    SYS_ALARM      = 0x06,
    SYS_EXEC       = 0x07,
    SYS_EXITS      = 0x08,
    SYS_SEGBRK     = 0x0C,
    SYS_OPEN       = 0x0E,
    SYS_RFORK      = 0x13,
    SYS_CREATE     = 0x16,
    SYS_FD2PATH    = 0x17,
    SYS_BRK_       = 0x18,
    SYS_REMOVE     = 0x19,
    SYS_NOTIFY     = 0x1C,
    SYS_NOTED      = 0x1D,
    SYS_SEGATTACH  = 0x1E,
    SYS_SEGDETACH  = 0x1F,
    SYS_SEMACQUIRE = 0x25,
    SYS_SEMRELEASE = 0x26,
    SYS_SEEK       = 0x27,
    SYS_STAT       = 0x2A,
    SYS_FSTAT      = 0x2B,
    SYS_WSTAT      = 0x2C,
    SYS_FWSTAT     = 0x2D,
    SYS_PREAD      = 0x32,
    SYS_PWRITE     = 0x33
};

#define OREAD 0 /* open for read */
#define OWRITE 1 /* write */
#define ORDWR 2 /* read and write */
#define OEXEC 3 /* execute, == read but check execute permission */
#define OTRUNC 16 /* or'ed in (except for exec), truncate file first */
#define OCEXEC 32 /* or'ed in, close on exec */
#define ORCLOSE 64 /* or'ed in, remove on close */
#define OEXCL 0x1000 /* or'ed in, exclusive use (create only) */

uvlong _syscall9(uvlong num, uvlong argv, uvlong arg1, uvlong arg2, uvlong arg3);

/* Thanks to g-w1 and the Zig project for code that I referenced */

static inline uvlong syscall9_1(uvlong num, uvlong arg0)
{
    return _syscall9(num, arg0, 0, 0, 0);
}

static inline long long syscall9_2(
        uvlong num,
        uvlong arg0,
        uvlong arg1)
{
    return _syscall9(num, arg0, arg1, 0, 0);
}

static inline uvlong syscall9_3(
        uvlong num,
        uvlong arg0,
        uvlong arg1,
        uvlong arg2)
{
    return _syscall9(num, arg0, arg1, arg2, 0);
}

static inline uvlong syscall9_4(
        uvlong num,
        uvlong arg0,
        uvlong arg1,
        uvlong arg2,
        uvlong arg3)
{
    return _syscall9(num, arg0, arg1, arg2, arg3);
}




#endif
