#include <stdarg.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <_9.h>
#include <_9syscall.h>
#include <string.h>

int _9ioctl(int fd, unsigned long request, ...)
{
	va_list a;

	if (request != TIOCGWINSZ && request != TIOCSWINSZ)
	{
		_FAIL_PRINT("Unimplemented ioctl: %d\n", request);
		return -ENOSYS;
	}

	char buf[sizeof("/dev/cons")];
	if (_9syscall_3(SYS_FD2PATH, fd, (uvlong) buf, sizeof("/dev/cons")) != 0)
		return -EBADF;
	if (strcmp(buf, "/dev/cons") != 0)
		return -ENOTTY;

	va_start(a, request);
	struct winsize *ptr = va_arg(a, struct winsize *);
	ptr->ws_col = 80;
	ptr->ws_row = 24;
	va_end(a);
	return 0;
}
