#include <_9syscall.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <stdbool.h>
#include <stdint.h>
#include <errno.h>
#include <errno9.h>
#include <stdint.h>
#include <_9.h>

void *_9mmap(
		void *addr,
		size_t length,
		int prot,
		int flags,
		int fd,
		off_t offset
	)
{
	const char *class;
	if (length == 0) return (void *) -EINVAL;

	if (flags & MAP_ANONYMOUS || flags & MAP_ANON) fd = -1;

	if (flags & MAP_SHARED || flags & MAP_SHARED_VALIDATE) class = "shared";
	else if (!(flags & MAP_PRIVATE)) return (void *) -EINVAL;
	else class = "memory";

	if (!(flags & MAP_FIXED)) addr = NULL;

	void *mapped = (void *) _9syscall_4(
			SYS_SEGATTACH,
			0,
			(uvlong) class,
			(uvlong) addr,
			length
		);

	if (mapped == (void *) -1) return (void *)(uvlong) -_syserrno();

	if (fd != -1)
	{
		size_t cur = _9syscall_3(SYS_SEEK, fd, 0, 1);
		if (cur < 0) return (void *)(uvlong) -_syserrno();
		if (_9syscall_3(SYS_SEEK, fd, offset, 1) < 0)
			return (void *)(uvlong) -_syserrno();
		_9syscall_4(SYS_PREAD, fd, (uvlong) mapped, length, -1);
		_9syscall_3(SYS_SEEK, fd, cur, 0);
	}
	return mapped;
}

int _9munmap(void *addr, size_t length)
{
	(void) length;
	_9syscall_1(SYS_SEGDETACH, (uvlong) addr);
	return -_syserrno();
}

extern void *_brk;
int brk(void *addr)
{
	_STRACE_PRINT("strace: brk %p\n", addr);
	if (_9syscall_1(SYS_BRK_, (uvlong) addr) < 0)
	{
		errno = ENOMEM;
		return -1;
	}
	_brk = addr;
	return 0;
}

void *sbrk(intptr_t inc)
{
	void *old = _brk;
	if (inc == 0) return old;
	return brk(old + inc) ? (void *) -1 : old;
}
