#include <stdint.h>

static inline int64_t le2m(const int8_t *from, int size)
{
    int64_t res;
    for (int i = 0; i < size; ++i) res |= from[i] << i*8;
    return res;
}

static inline void m2le(int64_t value, int8_t *to, int size)
{
    for (int i = 0; i < size; ++i) to[i] = (value >> i*8) & 0xFF;
}

static inline int64_t be2uint64(const int8_t from[8])
{
	int64_t res = 0;
	for (int i = 0; i < 8; ++i) res = (res << 8) | from[i];
	return res;
}
