#include <stddef.h>
#include <_9.h>
#include <_9syscall.h>
#include <fcntl.h>
#include <errno.h>
#include <limits.h>

char *_9getcwd(char *buf, size_t size)
{
	int n;
	int fd;

	if (size == 0 || buf == NULL) return (char *) -EINVAL;

	fd = _9open(".", O_RDONLY, 0);
	if (fd < 0) return (char *) -EACCES;

	n = _9syscall_3(SYS_FD2PATH, fd, (uvlong) buf, size);
	_9close(fd);
	if (n <= 0) return (char *) -EFAULT; /* Just a guess */
	return buf;
}
